c=======================================================================
c  This source code is public domain, and may be freely distributed,
c  modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO
c  WARRANTY OF ANY KIND.
c=======================================================================
c   fptest.f - create fingerprint for SMILES and show info
c=======================================================================
      program fptest
      include 'dt_f_smiles.inc'
      include 'dt_f_finger.inc'
c-----------------------------------------------------------------------
      integer    fp_h, mol, sobj
      integer    lensmiles, lenfp, lenbuff
      character*(2000) smiles, fp, buff
      logical ok
c-----------------------------------------------------------------------
c  Declare functions used
c-----------------------------------------------------------------------
      integer dt_f_fp_fingerprint, dt_f_fp_nbits, dt_f_fp_obits
      integer dt_f_smilin, dt_f_binary2ascii
      integer dt_f_fp_bitcount, dt_f_fp_obitcount, dt_f_stringvalue
      logical dt_f_dealloc
c-----------------------------------------------------------------------
c  Input and interpret SMILES
c-----------------------------------------------------------------------
10    continue
      print '(/A$)', 'Enter SMILES (or ''q'' to quit): '
      read (*, fmt='(Q,A)', err=1000) lensmiles, smiles
      if (smiles(1:1) .eq. 'q') go to 1000
      mol = dt_f_smilin(smiles(:lensmiles))
      if (mol .eq. NULL_OB) then
        print *, 'SMILES rejected...'
        go to 10
      endif
c-----------------------------------------------------------------------
c  Create fingerprint object
c-----------------------------------------------------------------------
      fp_h = dt_f_fp_fingerprint(mol, .true.)
c-----------------------------------------------------------------------
c  Query toolkit and print fingerprint characteristics
c-----------------------------------------------------------------------
      print *, 'Folded fingerprint size:   ', dt_f_fp_nbits(fp_h)
      print *, 'Unfolded fingerprint size: ', dt_f_fp_obits(fp_h)
      print *, 'Fingerprint bits-on count: ', dt_f_fp_bitcount(fp_h)
      print *, 'Unfolded bits-on count:    ', dt_f_fp_obitcount(fp_h)
c-----------------------------------------------------------------------
c  Print ascii value of fingerprint
c-----------------------------------------------------------------------
      lenbuff = dt_f_stringvalue(fp_h, buff)
      sobj = dt_f_binary2ascii(buff(:lenbuff))
      lenfp = dt_f_stringvalue(sobj, fp)
      print *, 'ASCII value of fingerprint:'
      print *, fp(:lenfp)
c-----------------------------------------------------------------------
c  Dealloc and loop back
c-----------------------------------------------------------------------
      ok = dt_f_dealloc(fp_h)
      ok = dt_f_dealloc(mol)
100   go to 10
c-----------------------------------------------------------------------
c  Drop here to exit program
c-----------------------------------------------------------------------
1000  continue
      print *, 'So long, baby!'
      end
