c=======================================================================
c  This source code is public domain, and may be freely distributed,
c  modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO
c  WARRANTY OF ANY KIND.
c=======================================================================
c   merrelease.f -- release a Merlin pool from memory
c=======================================================================
      program merrelease
      include 'dt_f_smiles.inc'
      include 'dt_f_datatype.inc'
      include 'dt_f_merlin.inc'
c-----------------------------------------------------------------------
      integer    server_h, pool_h, sos
      integer    hostlen, dblen, isnew
      character*(100) host, db
      logical ok
c-----------------------------------------------------------------------
c  Declare functions used
c-----------------------------------------------------------------------
      integer dt_f_mer_server, dt_f_open, dt_f_getusers
      logical dt_f_isopen, dt_f_release, dt_f_isheld
c-----------------------------------------------------------------------
c  Input host and database
c-----------------------------------------------------------------------
4     continue
      print '(/A$)', 'Enter hostname: '
      read (*, fmt='(Q,A)', err=4) hostlen, host
      server_h = dt_f_mer_server(host(:hostlen), 'merlin', 'thor',
     &                           ' ',isnew)
      if (NULL_OB .eq. server_h) then
        print *, 'Failed to connect to host: ', host(:hostlen)
        go to 1000
      endif
      print *, 'Connected to host: ', host(:hostlen)
5     continue
      print '(/A$)', 'Enter database: '
      read (*, fmt='(Q,A)', err=5) dblen, db
      ok = dt_f_isopen(server_h, db(:dblen))
      if (.not.ok) then
        print *, 'Pool neither loaded nor held...'
        go to 1000
      endif
      pool_h =dt_f_open(server_h, db(:dblen), 'r', ' ', isnew)
      if (NULL_OB .eq. pool_h) then
        print *, 'Failed to open pool...'
        go to 1000
      end if
      ok = dt_f_isheld(pool_h)
      if (.not.ok) then
        print *, 'Pool not held in memory...'
        go to 1000
      else
        print *, 'Releasing pool...'
        ok = dt_f_release(pool_h, ' ')
        if (.not.ok) then
          print *, 'Couldn''t release pool...'
        else
          sos = dt_f_getusers(pool_h)
          if (NULL_OB .eq. sos) then
            print *, 'Pool released from memory...'
          else
            print *, 'Pool will be released from memory when users'
     &               // ' disconnect...'
          endif
        endif
      endif
c-----------------------------------------------------------------------
c  Drop here to exit program
c-----------------------------------------------------------------------
1000  continue
      print *, 'So long, baby!'
      end
