c======================================================================
c  This source code is public domain, and may be freely distributed,
c  modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO
c  WARRANTY OF ANY KIND.
c======================================================================
c  pipetalker.f - talks to one program via a pipe.  This is a
c                 program-object-toolkit program, as opposed to
c                 a program-object ("talk") program, like echotalk
c                 or verbosetalk.
c----------------------------------------------------------------------
      program pipetalker
      include 'dt_f_smiles.inc'
      include 'dt_f_progob.inc'
c----------------------------------------------------------------------
c  Declarations - note that in fortran, handles are integers
c----------------------------------------------------------------------
      integer proglen, lenbuff
      integer sos, prog, msgout, msgin
      logical ok
      character*(100) progname
      character*(100) buff
c----------------------------------------------------------------------
c  Declare functions used.
c----------------------------------------------------------------------
      integer dt_f_alloc_seq, dt_f_alloc_string, dt_f_alloc_program
      integer dt_f_converse, dt_f_welcome
      logical dt_f_append
      logical du_f_zapseq, du_f_printsos
c-----------------------------------------------------------------------
c  Print banner
c-----------------------------------------------------------------------
      print *, '     *********************************************'
      print *, '     | pipetalker - progob demo program          |'
      print *, '     *********************************************'
      print *, '     |            Daylight CIS, Inc.             |'
      print *, '     |      Toolkit Demonstration Program        |'
      print *, '     *********************************************'
c----------------------------------------------------------------------
c  Input talk-program name; here the sos is the program name only
c  (no arguments).
c----------------------------------------------------------------------
5     continue
      print '(/A$)', 'Enter talk-program: '
      read (*, fmt='(Q,A)', err=5) proglen, progname
      sos = dt_f_alloc_seq()
      ok = dt_f_append(sos, dt_f_alloc_string(progname(:proglen)))
c----------------------------------------------------------------------
c  This call should actually fork the process
c----------------------------------------------------------------------
      prog =  dt_f_alloc_program(sos)
      ok = du_f_zapseq(sos)
      if (prog .eq. NULL_OB) then
        print '(A,A,A)',
     &  'Error: Cannot make prog-object: "', progname(:proglen), '"'
        go to 5
      endif
      ok = du_f_printsos(dt_f_welcome(prog))
20    continue
        read (*, fmt='(Q,A)', end=100) lenbuff, buff
        msgout = dt_f_alloc_string(buff(:lenbuff))
        msgin = dt_f_converse(prog, msgout)
        if (msgin .eq. NULL_OB) go to 100
        ok = du_f_printsos(msgin)
        ok = du_f_zapseq(msgout)
      go to 20
100   continue
      ok = du_f_printsos(dt_f_converse(prog, NULL_OB))
      end
