c======================================================================
c  This source code is public domain, and may be freely distributed,
c  modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO
c  WARRANTY OF ANY KIND.
c======================================================================
c  cansmi.f -- read smiles , write unique smiles
c----------------------------------------------------------------------
      program cansmi
      include 'dt_f_smiles.inc'
c----------------------------------------------------------------------
c  SMILES length limit is set here - the Toolkit doesn't impose one.
c----------------------------------------------------------------------
      integer MAXSMI
      parameter ( MAXSMI = 2000 )
c----------------------------------------------------------------------
c  Declarations - note that in fortran, handles are integers
c----------------------------------------------------------------------
      integer            mol
      integer            lensmi, lenusm, lenism, lenmsg
      character*(MAXSMI) smi,    usmi,   ismi,   msg
      logical            ok
c----------------------------------------------------------------------
c  Declare functions used.
c----------------------------------------------------------------------
      integer dt_f_smilin, dt_f_smilinerrtext, dt_f_cansmiles
      logical dt_f_dealloc
c----------------------------------------------------------------------
c  Loop over input
c----------------------------------------------------------------------
      print *, 'Demo program CANSMI (from cansmi.f)'
10    continue
	 print '(/A$)', 'Enter SMILES ..... '
         read (*, '(Q,A)', END=99) lensmi, smi
c----------------------------------------------------------------------
c  Create molecule by interpreting SMILES; print any warnings.
c----------------------------------------------------------------------
         mol    = dt_f_smilin(smi(:lensmi))
         if (mol .eq. NULL_OB) print *, 'Uninterpretable SMILES'
         lenmsg = dt_f_smilinerrtext(msg)
         if (lenmsg .gt. 0)    print *, msg(:lenmsg)
c----------------------------------------------------------------------
c  Print unique (non-isomeric) SMILES.
c----------------------------------------------------------------------
         lenusm = dt_f_cansmiles(mol, .false., usmi)
         if (lenusm .gt. 0)
     &      print *, 'Unique SMILES .... ', usmi(:lenusm)
c----------------------------------------------------------------------
c  Print unique isomeric SMILES only if different.
c----------------------------------------------------------------------
         lenism = dt_f_cansmiles(mol, .true., ismi)
         if (lenism.gt.0 .and. ismi.ne.usmi)
     &      print *, 'Isomeric SMILES .. ', ismi(:lenism)
c----------------------------------------------------------------------
c  Deallocate molecule before looping back for next.
c  Note that if DT_F_DEALLOC(NULL_OB) is not an error, just a no-op.
c----------------------------------------------------------------------
	 ok = dt_f_dealloc(mol)
      go to 10
c----------------------------------------------------------------------
c  Drop out of loop on EOF.
c----------------------------------------------------------------------
99    continue
      print *, 'Fini.'
      end
