c=======================================================================
c  This source code is public domain, and may be freely distributed,
c  modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO
c  WARRANTY OF ANY KIND.
c=======================================================================
c   thorpick.f -- selective db-to-TDT-file writer
c=======================================================================
      program thorpick
      include 'dt_f_smiles.inc'
      include 'dt_f_datatype.inc'
      include 'dt_f_thor.inc'
c-----------------------------------------------------------------------
      integer    server_h, db_h, tdt_h, tdt_stream, subtdt_stream
      integer    dtype_h, subtdt_h
      integer    hostlen, dblen, count, isnew, ofilelen, olun
      integer    bigcount, smallcount, i, j, bufflen, dlistlen
      integer    dtypelen
      character*(100) host, db, ofile, dlist, dtype, buff
      logical ok, excludemode, nonepicked
c-----------------------------------------------------------------------
c  Declare functions used
c-----------------------------------------------------------------------
      integer dt_f_thor_server, dt_f_open, dt_f_stream, dt_f_next
      integer dt_f_getdatatype
      logical dt_f_dealloc, dt_f_setadjunct
c-----------------------------------------------------------------------
c  Print banner
c-----------------------------------------------------------------------
      print *, '     *********************************************'
      print *, '     | thorpick - selective db-to-TDT-file dump  |'
      print *, '     *********************************************'
      print *, '     |            Daylight CIS, Inc.             |'
      print *, '     |      Toolkit Demonstration Program        |'
      print *, '     *********************************************'
c-----------------------------------------------------------------------
c  Input host and database
c-----------------------------------------------------------------------
5     continue
      print '(/A$)', 'Enter hostname: '
      read (*, fmt='(Q,A)', err=5) hostlen, host
      server_h = dt_f_thor_server(host(:hostlen), 'thor', 'thor',
     &                            ' ',isnew)
10    continue
      print '(/A$)', 'Enter database: '
      read (*, fmt='(Q,A)', err=10) dblen, db
      db_h =dt_f_open(server_h, db(:dblen), 'r', ' ', isnew)
      if ((NULL_OB .eq. server_h) .or. (NULL_OB .eq. db_h)) then
        print *, 'Failed to open database...'
        go to 1000
      end if
      print *, 'Connected to host ', host(:hostlen)
      print *, 'Opened database ', db(:dblen)
c-----------------------------------------------------------------------
c  Get output filename
c-----------------------------------------------------------------------
20    continue
      print '(/A$)', 'Enter output filename: '
      read (*, fmt='(Q,A)', err=20) ofilelen, ofile
      open (unit=olun, file=ofile(:ofilelen), status='new',
     &      access='sequential', err=20)
c-----------------------------------------------------------------------
c  Select datatypes or exclude ?
c-----------------------------------------------------------------------
30    continue
      print '(/A$)', '(S)elect or (e)xclude datatypes ? (select): '
      read (*, fmt='(Q,A)', err=30) bufflen, buff
      if (buff(1:1) .eq. 'e') then
        excludemode = .TRUE.
        print *, 'excludemode = .TRUE.'
      else
        excludemode = .FALSE.
        print *, 'excludemode = .FALSE.'
      endif
c-----------------------------------------------------------------------
c  Enter datatype list; parse list and "turn on" selected datatypes.
c-----------------------------------------------------------------------
40    continue
      print '(/A$)', 'Enter datatype list (e.g., "$SMI FP $NAM"): '
      read (*, fmt='(Q,A)', err=40) dlistlen, dlist
      if (dlistlen .eq. 0) go to 40
      i = 1
      dlist(dlistlen+1:dlistlen+1) = ' '
50    continue
      if (i .le. dlistlen) then
         j = index(dlist(i:), ' ')
         dtype = dlist(i:i+j-2)
         dtypelen = j - 1
         dtype_h = dt_f_getdatatype(db_h, dtype(:dtypelen))
         ok = dt_f_setadjunct(dtype_h, 1)
         i = i + j
         go to 50
      endif
c-----------------------------------------------------------------------
c  Stream TDTs, subTDTs, call pickyprint to pick and print.
c-----------------------------------------------------------------------
      tdt_stream = dt_f_stream(db_h, TYP_DATATREE)
      count = 0
      smallcount = 0
      bigcount = 0
60    continue
      tdt_h = dt_f_next(tdt_stream)
      if (tdt_h .eq. NULL_OB) go to 200
      nonepicked = .TRUE.
      call pickyprint(tdt_h, excludemode, nonepicked, olun)
      subtdt_stream = dt_f_stream(tdt_h, TYP_DATATREE)
70    continue
      subtdt_h = dt_f_next(subtdt_stream)
      if (subtdt_h .eq. NULL_OB) go to 100
      call pickyprint(subtdt_h, excludemode, nonepicked, olun)
      go to 70
100   continue
      if (.not. nonepicked) write (olun, '(A)') '|'
      ok = dt_f_dealloc(tdt_h)
c-----------------------------------------------------------------------
c  Progress dots
c-----------------------------------------------------------------------
      count = count + 1
      smallcount = smallcount + 1
      bigcount = bigcount + 1
      if (smallcount .eq. 20) then
        print '(/A$)', '.'
        smallcount = 0
      endif
      if (bigcount .eq. 1000) then
        print '(/A$)', ' '
        print '(I7)', count
        print '(A)', ' TDT''s'
        bigcount = 0
      endif
      go to 60
200   continue
c-----------------------------------------------------------------------
c  Drop here to exit program
c-----------------------------------------------------------------------
1000  continue
      print *, 'TDTs out: ', count
      end
c=======================================================================
c  pickyprint - prints selected dataitems in a TDT
c=======================================================================
      subroutine pickyprint(tdt_h, excludemode, nonepicked, olun)
      include 'dt_f_smiles.inc'
      include 'dt_f_datatype.inc'
      include 'dt_f_thor.inc'
c-----------------------------------------------------------------------
      integer    tdt_h, dtype_h, ditem_stream, ditem_h, adjunctval
      integer    olun, ditemlen
      character*(5000) ditem
      logical    excludemode, nonepicked
c-----------------------------------------------------------------------
c  Declare functions used
c-----------------------------------------------------------------------
      integer dt_f_stream, dt_f_next, dt_f_datatype, dt_f_adjunct
c-----------------------------------------------------------------------
c  Stream data items; if (excludemode) XOR (dataitem listed) call
c  du_ditem2str to provide dataitem-string.  Don't print null dataitems.
c-----------------------------------------------------------------------
      ditem_stream = dt_f_stream(tdt_h, TYP_DATAITEM)
10    continue
      ditem_h = dt_f_next(ditem_stream)
      if (ditem_h .eq. NULL_OB) go to 100
      dtype_h = dt_f_datatype(ditem_h)
      adjunctval = dt_f_adjunct(dtype_h)
      if ((.not. excludemode) .and. (adjunctval .eq. 1) .or.
     &    (excludemode)       .and. (adjunctval .ne. 1)) then
        call du_ditem2str(ditem_h, ditem, ditemlen)
        if (ditemlen .gt. 0) write (olun, '(A)') ditem(:ditemlen)
        nonepicked = .FALSE.
      endif
      go to 10
100   continue
      end
c=======================================================================
c  du_ditem2str - returns string including tag for a dataitem handle;
c                 ditemlen = 0 returned for null dataitems.
c=======================================================================
      subroutine du_ditem2str(ditem_h, ditem, ditemlen)
      include 'dt_f_smiles.inc'
      include 'dt_f_datatype.inc'
      include 'dt_f_thor.inc'
c-----------------------------------------------------------------------
      character*(5000) ditem, f
      integer    ditem_h, dfield_stream, dfield_h, sobj, dtype_h
      integer    flen, ditemlen, taglen
      character*(100)  tag
      logical    nodata
c-----------------------------------------------------------------------
c  Declare functions used
c-----------------------------------------------------------------------
      integer dt_f_datatype, dt_f_stream, dt_f_next, dt_f_binary2ascii
      integer dt_f_stringvalue
      logical dt_f_dfnorm
c-----------------------------------------------------------------------
c  Get and print tag.
c-----------------------------------------------------------------------
      dtype_h = dt_f_datatype(ditem_h)
      taglen = dt_f_stringvalue(dtype_h, tag)
      ditem(1:taglen+1) = tag(:taglen) // '<'
      ditemlen = taglen + 1
c-----------------------------------------------------------------------
c  Stream datafields; convert if binary; append to ditem.
c-----------------------------------------------------------------------
      nodata = .TRUE.
      dfield_stream = dt_f_stream(ditem_h, TYP_DATAFIELD)
10    continue
      dfield_h = dt_f_next(dfield_stream)
      if (dfield_h .eq. NULL_OB) go to 100
      if (dt_f_dfnorm(dfield_h, DX_THOR_BINARY)) then
        flen = dt_f_stringvalue(dfield_h, f)
        sobj = dt_f_binary2ascii(f)
        flen = dt_f_stringvalue(sobj, f)
      else
        flen = dt_f_stringvalue(dfield_h, f)
      endif
      ditem(ditemlen+1:) = f(:flen) // ';'
      ditemlen = ditemlen + flen + 1
      if (flen .gt. 0) nodata = .FALSE.
      go to 10
100   continue
c-----------------------------------------------------------------------
c  If we're out of data, change the last ";" to a ">".
c  If all fields are null (nodata), return ditemlen = 0.
c-----------------------------------------------------------------------
      ditem(ditemlen:ditemlen) = '>'
      if (nodata) ditemlen = 0
      return
      end
